library ieee;

use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;


entity operazioni is
	port ( din: in std_logic_vector(15 downto 0);
		   clk, start: in std_logic;
		   ris: out std_logic_vector(15 downto 0);
		   fine: out std_logic);
end operazioni;

architecture beh of operazioni is
type stati is (idle, letop,let0,let1,and_or,cnt_par);
signal st: stati;
signal count : integer range 0 to 1;
signal en_op,en_l0,en_l1, en_andor,en_cntpar: std_logic;
signal d0,d1: std_logic_vector(15 downto 0);
signal op: std_logic_vector( 1 downto 0);
begin
	
	process(clk)
	begin
		if clk'event and clk='0' then
			case st is
				when idle => if start ='1' then st <= letop;
				              else st <= idle;
							 end if;
				when letop => st <= let0;
				when let0 => if op(1) = '0' then st <= let1;
						 	 else st <= cnt_par;
							 end if;
				when let1 => st <= and_or;
				when cnt_par =>  if count = 1 then
										st <= idle;
								 else st <= cnt_par;
								 end if;
				when others => st <= idle;
			end case; 
		  end if;
		end process;
			
en_op <= '1' when st = letop else
	'0';
	
en_l0 <= '1' when st = let0 else
	'0';

en_l1 <= '1' when st = let1 else 
	'0';
en_andor<= '1' when st = and_or else 
	'0';
en_cntpar<= '1' when st = cnt_par else
	'0';
	
process(clk)
variable conta1: integer range 0 to 16;
begin
	if clk'event and clk='0' then
		if en_op='1' then op <= din(1 downto 0);
		end if;
		if en_l0 = '1' then d0 <= din;
			                 count <= 0;
		end if;
		if en_l1 = '1' then d1 <= din;
		end if;
		if en_andor = '1' then
			if op = "00" then -- and
				ris <= d0 and d1;
			else ris <= d0 or d1; -- or
			end if;		 
			--fine <= '1';
		end if;
		if en_cntpar = '1' then	
			if count < 1 then count <= 1;
			else 		
				--fine <= '1';
				conta1:=0;
				for i in  0 to 15 loop
					if d0(i) = '1' then conta1:= conta1+1;
					end if;
				end loop;
				
				if op = "10" then 
				-- cnt	 
				  ris <= conv_std_logic_vector(conta1, 16);
				else if conta1 mod 2 = 0 then
					    ris <= conv_std_logic_vector(1,16);
					    -- ris(15 downto 1) <= (others => '0');
					    -- ris(0) <= '1';
					else ris <= conv_std_logic_vector(0,16);
					end if;
				end if;	
			end if;
		end if;
   --if en_op /= '1' and en_l0 /= '1' and en_l1/= '1' and (en_andor='1' or (en_cntpar='1' and count = 1) )then 
	   if (en_andor='1' or (en_cntpar='1' and count = 1) )then
	   fine <= '1';
   else fine <= '0';
   end if;
  end if; 
  end process;
  end beh;
  
		
					
					
			
